/* LFN Functions (Win95/WinNT) 1.0.0
 *   Emulates syntax of Borland-C++ Equivalent SFN functions.
 *   Will automatically call SFN functions if LFN not available.
 *  Copyright (c) 1996 by Peter Johnson.  All rights reserved.
 *  This code may be used and modified as users see fit, as long
 *   as the original copyright is unaltered.
 *  E-mail Peter Johnson (locke@mcs.net) if you have any questions.
 */


/* LFN/SFN version of ffblk structure */
struct ffblk_lfn
{
	long lfn_handle;		/* LFN handle (0 if SFN) */
	unsigned short lfn_ctime;	/* LFN */
	unsigned short lfn_cdate;	/* LFN */
	unsigned short lfn_atime;	/* LFN */
	unsigned short lfn_adate;	/* LFN */
	unsigned long ff_attrib;	/* attribute found */
	unsigned short ff_ftime;	/* file time */
	unsigned short ff_fdate;	/* file date */
	long ff_fsize;			/* file size */
	char ff_name[260];		/* filename */
	char ff_reserved[21];		/* SFN reserved */
};

int lfn_findfirst(const char *pathname, struct ffblk_lfn *ffblk, int attrib);
int lfn_findnext(struct ffblk_lfn *ffblk);
int lfn_getshortpath(const char *longpath, char *shortpath);
int lfn_getshortname(const char *longname, char *shortname);
int lfn_getcurdir(int drive, char *directory);
char *lfn_getcwd(char *buf, int buflen);
int lfn_rename(const char *oldname, const char *newname);
int lfn_chdir(const char *path);
int lfn_remove(const char *filename);
FILE *lfn_fopen(const char *filename, const char *mode);
int lfn_fclose(FILE *file);
int lfn_fcloseall(void);
