#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <string.h>
#include <io.h>
#include "lfn.h"


typedef union convtime_u
{
	struct ftime data;
	struct {short time; short date;} dos;
} CONVTIME;

void printfileinfo(struct ffblk_lfn file);

int main()
{
	struct ffblk_lfn file;
	int ret;
	char dir[260];
	char dir2[260];
	
	if(lfn_getcwd(dir, 260))
		printf("current dir (LFN): %s\n", dir);
	else
		return 0;
	ret=lfn_getshortpath(dir, dir2);
	if(ret)
	{
		printf("Error: %i\n", ret);
		return 0;
	}
	printf("Converted to SFN: %s\n", dir2);
	
	ret=lfn_findfirst("*.*", &file, FA_DIREC);
	if(ret)
	{
		printf("Error: %i\n", ret);
		return 0;
	}
	printfileinfo(file);
	while(!lfn_findnext(&file))
		printfileinfo(file);
	
	return 0;
}

void printfileinfo(struct ffblk_lfn file)
{
	CONVTIME fileconv;
	int ret;
	char sfn[260];
	fileconv.dos.time = file.ff_ftime;
	fileconv.dos.date = file.ff_fdate;
	
	if(file.ff_attrib & FA_DIREC)
		printf("[dir ] ");
	else
		printf("[file] ");
	
	printf("[%2i-%2i-%i] ", fileconv.data.ft_month,
		fileconv.data.ft_day, fileconv.data.ft_year+1980);
	printf("[%2i:%2i:%2i] ", fileconv.data.ft_hour,
		fileconv.data.ft_min, fileconv.data.ft_tsec * 2);
	
	ret=lfn_getshortname(file.ff_name, sfn);
	if(ret)
	{
		printf("Error: %i\n", ret);
		return;
	}
	printf(" %s", file.ff_name);
	
	printf("\n\t\t\t\t(%s)", sfn);
		
	printf("\n");
}
