/* kluStor v.3.0.1
 *  Copyright (c) 1997 by Peter Johnson (locke@mcs.net).
 *  Read Doc/copying.pj for usage information.
 *
 * File: kluMake.cpp
 * Desc: kluStor entry deleter
 */

#include <stdio.h>
#include <stdlib.h>

#include "kluStor.h"

/* Progress
 * Progress callback for save
 */
bool Progress(const char *curname, unsigned long num, unsigned long totnum, unsigned long pos)
{
	printf("\r%3lu/%3lu (%5lu kb) %-60s", num, totnum, pos/1024, curname);
	fflush(stdout);
	return true;
}

int main(int argc, char *argv[])
{
	kluFile *kf;
	
	if(argc!=3)	// check args
	{
		printf("Usage:\nkluDel <file> (w/ .klu extension) <name>\n");
		return 1;
	}

	kf = new kluFile(argv[1], false);	// open klufile w/o subdir scan
	
	kf->dir.Delete(argv[2]);	// delete entry
	if(kf->dir.GetError())
	{
		fprintf(stderr, "Error: %s\n", kf->GetError());
		delete kf;
		return 1;
	}
	
	printf("Saving...\n");
	char *fn = tmpnam(NULL);
	kf->Save(fn, false, false, 1, &Progress);	// save to a temp file
	puts("");
	if(kf->GetError())
	{
		fprintf(stderr, "Error: %s\n", kf->GetError());
		delete kf;
		return 1;
	}
	else
	{
		delete kf;
		remove(argv[1]);	// delete old klufile
		rename(fn, argv[1]);	// rename new to old
	}
	return 0;
}
