/* kluStor v.3.0.1
 *  Copyright (c) 1997 by Peter Johnson (locke@mcs.net).
 *  Read Doc/copying.pj for usage information.
 *
 * File: kluDir.cpp
 * Desc: kluStor [sub]directory lister
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>

#include "kluStor.h"
#include "kluCmp.h"

int main(int argc, char *argv[])
{
	if(argc<2 || argc>4)
	{
		printf("Usage:\nkluDir <file> (w/ .klu extension) [subdir] [-x]\n");
		printf("\t-x\tInclude entries from external dirs\n");
		return 1;
	}
	bool ReadExternal = false;	// -x flag
	int DirArg = 0;
	for(int arg=2; arg<argc; arg++)
	{
		if(!strncmp(argv[arg], "-x", 2))
			ReadExternal = true;
		else
			DirArg = arg;
	}
			
	kluFile kf(argv[1], ReadExternal);	// open klu file
	kluDir kd(kf, DirArg!=0?argv[DirArg]:NULL);	// get subdir
	
	// print out directory listing
	unsigned long num = kd.GetNumEntries();
	printf("+----Size+Cmp Size+Type+Name--------------------------------------------------\n");
	for(unsigned long i=0;i<num;i++)
		printf("|%8lu|%8lu|%4s|%-55s\n", kd.GetSize(i), kd.GetCompSize(i),
			kd.IsExternal(i)?"Ext":kluCompress[kd.GetCompType(i)].name,
			kd.GetName(i));
	return 0;
}
