/* kluStor v.3.0.1
 *  Copyright (c) 1997 by Peter Johnson (locke@mcs.net).
 *  Read Doc/copying.pj for usage information.
 *
 * File: kluMake.cpp
 * Desc: kluStor file creator
 */

#include <stdio.h>
#include <stdlib.h>

#include "kluStor.h"

/* Progress
 * Progress callback for save
 */
bool Progress(const char *curname, unsigned long num, unsigned long totnum, unsigned long pos)
{
	printf("\r%3lu/%3lu (%5lu kb) %-60s", num, totnum, pos/1024, curname);
	fflush(stdout);
	return true;
}

int main(int argc, char *argv[])
{
	kluFile *kf;
	
	if(argc!=2)	// check args
	{
		printf("Usage:\nkluMake <file> (w/ .klu extension)\n");
		return 1;
	}

	kf = new kluFile(argv[1]);	// create klu file, w/ ext. scan
	
	printf("Saving...\n");
	char *fn = tmpnam(NULL);
	kf->Save(fn, true, false, 1, &Progress);	// save it
	puts("");
	if(kf->GetError())	// check for errors
	{
		fprintf(stderr, "Error: %s\n", kf->GetError());
		delete kf;
		return 1;
	}
	else
	{
		delete kf;
		remove(argv[1]);	// delete & rename
		rename(fn, argv[1]);
	}
	return 0;
}
